/** @file sysc_ipc.c

@copyright Copyright (c) 2018 Microsemi Corporation. All Rights Reserved.

Description: sysCore interprocess communication header

*/

#ifndef SC_DISABLE_MESSAGE_QUEUE

#include "psysc_types.h"

/** Define the following specific to the platform:
 * - MESSAGE_QUEUE and PMESSAGE_QUEUE
 */

/** An example of MESSAGE_QUEUE and PMESSAGE_QUEUE definitions is shown below. */
struct _MESSAGE_QUEUE
{
   /** Define other members specific to the platform. */
   void *queue_handle;
};
typedef struct _MESSAGE_QUEUE MESSAGE_QUEUE;
typedef struct _MESSAGE_QUEUE *PMESSAGE_QUEUE;

SA_BOOL SC_MessageQueueCreate(PMESSAGE_QUEUE *mq,
      const char *queue_name,
      SA_UINT32 max_message_count,
      SA_UINT32 message_len)
{
   SA_BOOL success = kFalse;
   *mq = (PMESSAGE_QUEUE)SA_malloc(sizeof(MESSAGE_QUEUE));

   return (*mq ? kTrue : kFalse);
}

SA_BOOL SC_MessageQueueSend(PMESSAGE_QUEUE mq, const void *msg, SA_UINT32 message_len, SA_UINT32 flags)
{
   SA_BOOL success = kFalse;

   return success;
}

SA_BOOL SC_MessageQueueReceive(PMESSAGE_QUEUE mq, void *msg, SA_UINT32 message_len, SA_UINT32 flags)
{
   SA_BOOL success = kFalse;

   return success;
};

SA_BOOL SC_MessageQueueDelete(PMESSAGE_QUEUE mq)
{
   SA_BOOL success = kFalse;

   return success;
}

#endif /* SC_DISABLE_MESSAGE_QUEUE */
