/** @file sysc_threads.c

Copyright (c) 2021 Microchip Technology Inc. All Rights Reserved.

Description: Template sysCore threads source file

*/

#ifndef SC_DISABLE_THREAD_API

#include "psysc_platform.h"
#include "psysc_types.h"
#include "psysc_debug.h"

/** Define the following specific to the platform:
 * - THREAD_HANDLE and PTHREAD_HANDLE
 * - ThreadRoutine
 */

/** An example of THREAD_HANDLE and PTHREAD_HANDLE definitions is shown below. */
struct _THREAD_HANDLE
{
   /** Define other members specific to the platform. */
   void *handle;
};
typedef struct _THREAD_HANDLE THREAD_HANDLE;
typedef struct _THREAD_HANDLE *PTHREAD_HANDLE;

/** An example of ThreadRoutine definition is shown below. */
typedef void*(*ThreadRoutine)(void*);

SA_DWORD SC_GetCurrentThreadID()
{
   /*
   return (SA_DWORD)pthread_self();
   */
   return (SA_DWORD)0;
}

/* *****************
 * Thread Create/Delete
 */

SA_BOOL _SC_ThreadHandleCreate(PTHREAD_HANDLE *handle)
{
   *handle = (PTHREAD_HANDLE)SA_malloc(sizeof(THREAD_HANDLE));
   return (*handle ? kTrue : kFalse);
}

SA_BOOL _SC_ThreadHandleDestroy(PTHREAD_HANDLE handle)
{
   if (handle)
   {
      SA_free(handle);
   }
   return kTrue;
}

/* *****************
 * Thread Start/Join
 */

SA_BOOL _SC_ThreadStart(PTHREAD_HANDLE handle, ThreadRoutine routine, void * param)
{
   /*
   handle->handle = ((OS_THREAD_HANDLE_T)pthread_create(&handle->id, 0, routine, param) ? 0 : 1);
   */
   SC_CHECK(handle->handle != 0, "Failed to start thread");
   return (handle->handle ? kTrue : kFalse);
}

SA_BOOL _SC_ThreadJoin(PTHREAD_HANDLE handle)
{
   SA_BOOL success = kFalse;
   /*
   success = (pthread_join(handle->id, (void**)0) == 0 ? kTrue : kFalse);
   */
   SC_CHECK(success, "Failed to join thread");
   return success;
}

#endif /* SC_DISABLE_THREAD_API */

